AlliedInfantryTypes = { "e1", "e1", "e1", "e3", "e3",}
AlliedArmorTypes = { "1tnk", "2tnk", "jeep"}

IdlingUnits = { }
AttackGroupSize = 3

AlliedAttackPath = { Attack1, Attack2, SovBase }
AlliedAttackPathSouth = { Attack1, Attack2south, SovBase }

InfAttack = { }
TankAttack = { }

Rallypoints = { Rallypoint }
Barracks = { Rax }
Warfactory = { Wafa }

BuildVehicles = true
TrainInfantry = true
Attacking = true

Tick = function()
	if allies.HasNoRequiredUnits() 
	and greece.HasNoRequiredUnits() then
		ussr.MarkCompletedObjective(KillAll)
	end
end

IdleHunt = function(unit) if not unit.IsDead then Trigger.OnIdle(unit, unit.Hunt) end end


ProduceInfantry = function()

	local delay = Utils.RandomInteger(DateTime.Seconds(3), DateTime.Seconds(9))
	local toBuild = { Utils.Random(AlliedInfantryTypes) }
	allies.Build(toBuild, function(unit)
		InfAttack[#InfAttack + 1] = unit[1]

		if #InfAttack >= 8 then
			SendUnits(InfAttack, AlliedAttackPathSouth)
			InfAttack = { }
			Trigger.AfterDelay(DateTime.Minutes(3), ProduceInfantry)
		else
			Trigger.AfterDelay(delay, ProduceInfantry)
		end
	end)
end

ProduceTanks = function()

	local delay = Utils.RandomInteger(DateTime.Seconds(12), DateTime.Seconds(17))
	local toBuild = { Utils.Random(AlliedArmorTypes) }
	allies.Build(toBuild, function(unit)
		TankAttack[#TankAttack + 1] = unit[1]

		if #TankAttack >= 5 then
			SendUnits(TankAttack, AlliedAttackPath)
			TankAttack = { }
			Trigger.AfterDelay(DateTime.Minutes(3), ProduceTanks)
		else
			Trigger.AfterDelay(delay, ProduceTanks)
		end
	end)
end

SendUnits = function(units, waypoints)
	Utils.Do(units, function(unit)
		if not unit.IsDead then
			Utils.Do(waypoints, function(waypoint)
				unit.AttackMove(waypoint.Location)
			end)
			unit.Hunt()
		end
	end)
end

InitProductionBuildings = function()
	if not Wafa.IsDead then
		Wafa.IsPrimaryBuilding = true
		Trigger.OnKilled(Wafa, function() BuildVehicles = false end)
	else
		BuildVehicles = false
	end

	if not Rax.IsDead then
		Rax.IsPrimaryBuilding = true
		Trigger.OnKilled(Rax, function() TrainInfantry = false end)
	else
		TrainInfantry = false
	end
end

ActivateAI = function()

	InitProductionBuildings()

	Trigger.AfterDelay(DateTime.Seconds(10), function()
		ProduceInfantry()
		ProduceTanks()
	end)
end

InitObjectives = function()
	Trigger.OnObjectiveAdded(ussr, function(p, id)
		Media.DisplayMessage(p.GetObjectiveDescription(id), "New " .. string.lower(p.GetObjectiveType(id)) .. " objective")
	end)

	alliesObj = allies.AddPrimaryObjective("Deny the Soviets.")
	KillAll = ussr.AddPrimaryObjective("Eliminate all Allied and Greek local units in this area.")

	Trigger.OnObjectiveCompleted(ussr, function(p, id)
		Media.DisplayMessage(p.GetObjectiveDescription(id), "Objective completed")
	end)
	Trigger.OnObjectiveFailed(ussr, function(p, id)
		Media.DisplayMessage(p.GetObjectiveDescription(id), "Objective failed")
	end)

	Trigger.OnPlayerLost(ussr, function()
		Media.PlaySpeechNotification(player, "Lose")
	end)
	Trigger.OnPlayerWon(ussr, function()
		Media.PlaySpeechNotification(player, "Win")
	end)
end

WorldLoaded = function()
	allies = Player.GetPlayer("Allies")
	ussr = Player.GetPlayer("USSR")
	greece = Player.GetPlayer("Greece")

	InitObjectives()
	ActivateAI()
end
